"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const Sequelize = require("sequelize");
const user_util_1 = require("./../utils/user-util");
exports.initUserModel = (sequelize, userModelPath = null) => {
    let UserModel;
    if (userModelPath) {
        const path = path_1.resolve(process.cwd(), userModelPath);
        UserModel = sequelize.import(path);
    }
    else {
        const attributes = {
            username: { type: Sequelize.STRING, allowNull: false, unique: true },
            password: { type: Sequelize.STRING, allowNull: false },
            firstName: { type: Sequelize.STRING },
            lastName: { type: Sequelize.STRING },
            email: { type: Sequelize.STRING }
        };
        UserModel = sequelize.define('users', attributes);
    }
    UserModel.beforeCreate(user => {
        return user_util_1.hashPassword(user.password).then(hashed => {
            user.password = hashed;
        });
    });
    exports.User = UserModel;
    return UserModel;
};
//# sourceMappingURL=user-model.js.map